setfenv(1, ShinyEnv)

if not ShinyLocale then return end

-- The following stuff is unfortunately necessary, because some addons *override*
-- the tooltip handlers instead of hooking them :(

local f = CreateFrame("Frame")
local entered = false
local elapsed = 0
local timerStarted = false

f:SetScript("OnEvent", function(f, e, ...) f[e](f, ...) end)


function f:PLAYER_ENTERING_WORLD()
	entered = true
	f:ScheduleHook()
end


function f:ADDON_LOADED()
	if entered then
		f:ScheduleHook()
	end
end


function f:PLAYER_SPECIALIZATION_CHANGED(frame, ...)
	ShinyStats:UpdatePrimaryStat()
	--[===[@debug@
	print("Event", "PLAYER_SPECIALIZATION_CHANGED", ShinyStats.primaryStat)
	--@end-debug@]===]
end


function f:PLAYER_TALENT_UPDATE(frame, ...)
	ShinyStats:UpdatePrimaryStat()
	--[===[@debug@
	print("Event", "PLAYER_TALENT_UPDATE", ShinyStats.primaryStat)
	--@end-debug@]===]
end


function f:ScheduleHook()
	if timerStarted then
		elapsed = 0
	else
		f:SetScript("OnUpdate", f.OnTimer)
	end
end


function f:OnTimer(eps)
	elapsed = elapsed + eps
	if elapsed >= 3 then
		f:SetScript("OnUpdate", nil)

		f:UnregisterEvent("PLAYER_ENTERING_WORLD")
		f:UnregisterEvent("ADDON_LOADED")

		ShinyStats:HookTooltips()
		ShinyStats:UpdatePrimaryStat()
	end
	-- elseif elapsed >= 10 then
	-- 	f:SetScript("OnUpdate", nil)
	-- 	f:SetScript("OnUpdate", nil)
		
	-- 	ShinyStats:UpdatePrimaryStat()
	-- 	--[===[@debug@
	-- 	print("Event", "OnTimer(10)", ShinyStats.primaryStat)
	-- 	--@end-debug@]===]
	-- end
end

f:RegisterEvent("PLAYER_ENTERING_WORLD")
f:RegisterEvent("ADDON_LOADED")
f:RegisterEvent("PLAYER_SPECIALIZATION_CHANGED")
f:RegisterEvent("PLAYER_TALENT_UPDATE")